/*------------------------------------------------------------------------------
--  This file is a part of the libuc, microcontroler library
--  Copyright (C) 2013, Alexis Jeandet
--
--  This program is free software; you can redistribute it and/or modify
--  it under the terms of the GNU General Public License as published by
--  the Free Software Foundation; either version 3 of the License, or
--  (at your option) any later version.
--
--  This program is distributed in the hope that it will be useful,
--  but WITHOUT ANY WARRANTY; without even the implied warranty of
--  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
--  GNU General Public License for more details.
--
--  You should have received a copy of the GNU General Public License
--  along with this program; if not, write to the Free Software
--  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
-------------------------------------------------------------------------------
--                 Author : Alexis Jeandet
--                   Mail : alexis.jeandet@member.fsf.org
-------------------------------------------------------------------------------*/

#include <gpio.h>

#define bsp_gpio_init_list(list) __bsp_gpio_init_list(list,sizeof(list)/sizeof(gpioinitlist_str))

typedef struct
{
    gpio_t gpio;
    gpioconfig_str config;
}gpioinitlist_str;



void __bsp_gpio_init_list(gpioinitlist_str* list, int len)
{
    for(int i=0;i<len;i++)
    {
        gpioopenandconfig(list[i].gpio,&(list[i].config));
    }
}

void bsp_gpio_set_outputs(gpio_t* GPIO_Out_init_List,int len)
{
    gpio_t GPIO_init;
    for(int i=0;i<len;i++)
    {
        GPIO_init = gpioopen(GPIO_Out_init_List[i]);
        gpiosetconfig(GPIO_init,gpiooutdir,gpiohighspeed,gpiopushpulltype,gpionopulltype);
    }
}

void bsp_gpio_set_inputs(gpio_t* GPIO_In_init_List,int len)
{
    for(int i=0;i<len;i++)
    {
        gpio_t GPIO_init = gpioopen(GPIO_In_init_List[i]);
        gpiosetconfig(GPIO_init,gpioindir,gpiohighspeed,0,0);
    }
}







